/**
 * JBoss, Home of Professional Open Source
 * Copyright 2008, Red Hat Middleware LLC, and individual contributors
 * by the @authors tag. See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.jboss.webbeans.environment.se.bootstrap;

import org.jboss.webbeans.resource.AbstractNamingContext;

import javax.naming.Context;

/**
 *
 * @author JBoss.org, modifications by Peter Royle
 */
public class MockNaming
    extends AbstractNamingContext
{
    private Context context;

    public void setContext( Context context )
    {
        this.context = context;
    }

    public Context getContext(  )
    {
        return context;
    }

    public void bind( String key, Object value )
    {
        if ( context != null )
        {
            super.bind( key, value );
        }
    }

    public <T> T lookup( String name, Class<?extends T> expectedType )
    {
        if ( context != null )
        {
            T instance = overrideLookup( name, expectedType );

            if ( instance == null )
            {
                instance = super.lookup( name, expectedType );
            }

            return instance;
        } else
        {
            return null;
        }
    }

    @SuppressWarnings( "unchecked" )
    private <T> T overrideLookup( String name, Class<?extends T> expectedType )
    {
        return null;
    }
}
